/*
 * ̃vO̒쌠AgpAۏ؂̔۔FɂẮA
 * "LICENCE.txt"QƂ̂
 */

/* 
 * zvvO
 * Ver. 1.1 
 */

/* ̃t@C(measurement.cpp)́Av̏Ɋւ鏔֐܂ށB
 */

#include	<windows.h>
#include	<stdio.h>
#include	<process.h>
#include	<math.h>

//#include	"resource.h"
#include	"Resuser interface.h"
#include	"measurement.h"
#include	"state.h"
#include	"option.h"

/* Ot@CŒ`ꂽ֐̐錾ivg^Cv錾j
 * O[oϐ̐錾
 */
	/* "winmain.cpp"QƂ̂ */
	void DisplayInformation (char *buf);
	extern HWND	hwnd_dlg;

	/* "display.cpp"QƂ̂ */
	void RefreshDisplay();
	void SetCircle (double x_pos, double y_pos);

	/* "save.cpp"QƂ̂ */
	void SaveInTheFile (DWORD option, char *sbuf);
	void SaveMemo();

	/* "time.cpp"QƂ̂ */
	void TimeMillisecond (double *pTime);
	void TimeSecond (double *pTime);

/* ̃t@CŒ`֐̐錾ivg^Cv錾j */
unsigned _stdcall Measurement (void *param);

/* ̃t@CŒ`O[oϐ̐錾 */
DWORD	measurement_state;
HANDLE	hComEvent;		/* Xbhւ̒ʒmpCxgIuWFNg̃nh */
HANDLE	hTriggerEvent;	/* 葱sʒmpCxgIuWFNg̃nh */

/************* ̃t@CŌĂяo֐ *****************************/
/* InitMeasurement:  */
void InitMeasurement()
{
	hComEvent = CreateEvent (NULL, FALSE, FALSE, NULL);
	if (!hComEvent) {
		DisplayInformation ("error: hComEvent = CreateEvent()");
	}

	hTriggerEvent = CreateEvent (NULL, FALSE, FALSE, NULL);
	if (!hTriggerEvent) {
		DisplayInformation ("error: hComEvent = CreateEvent()");
	}

	return;
}

/* RegisterState: ԁistate.hQƁj̓o^ */
void RegisterState (DWORD state)
{
	measurement_state = state;
	return;
}

/* StartMeasurement: Jn */
void StartMeasurement()
{
	HANDLE	threadHandle;	
	DWORD	threadID;

	threadHandle = (HANDLE)_beginthreadex(0, 0, Measurement, 
					NULL, 0, (unsigned *) &threadID);
	CloseHandle (threadHandle);
	return;
}

/* TriggerMeasurement: 𑱍s */
void TriggerMeasurement()
{
	SetEvent(hTriggerEvent);
	return;
}

/* StopMeasurement: ~ */
void StopMeasurement()
{
	SetEvent(hComEvent);
	SetEvent(hTriggerEvent);
	return;
}

/* EndMeasurement: I */
void EndMeasurement()
{ 
	CloseHandle (hComEvent);
	CloseHandle (hTriggerEvent);
	return;
}

/************* ̃t@Cł̂ݎgp֐ ***********************/
/* Measurement: pXbh֐ */
unsigned _stdcall Measurement (void *param)
{
	DWORD count;
	double	time_0, time_1, elapsed_time;

	double	x_data, y_data;	

	char	cbuf[STRING_LENGTH]	= "";

	count = 1;

	while (1) {
		if (WaitForSingleObject(hTriggerEvent, INFINITE) == WAIT_OBJECT_0){
			if (WaitForSingleObject(hComEvent, 0) == WAIT_OBJECT_0)
			break;
		}
	
		sprintf (cbuf, "%d", count);
		SetDlgItemText (hwnd_dlg, IDC_COUNT, cbuf);

		if (count==1) {
			RefreshDisplay();
			elapsed_time = 0;
			TimeSecond (&time_0);	/* ̎擾 */
		}

		/* f[^v̈ʒǔvZivvO~Oł̃f[^擾ɑΉj */					
		x_data = WAVE_LENGTH * ((double)count/DEFAULT_COUNTS);		
		y_data = AMPLITUDE * sin (2 * PAI * (double)count/DEFAULT_COUNTS);		
		TimeSecond (&time_1);	/* ̎擾 */ 

		/* oߎԂ̌vZƕ\ */
		elapsed_time = elapsed_time + (time_1 - time_0);
		time_0 = time_1;
		sprintf (cbuf, "%5.2f", elapsed_time);
		SetDlgItemText (hwnd_dlg, IDC_ELAPSED_TIME, cbuf);

		/* f[^̕\ */
		SetCircle (x_data/X_MAX, y_data/Y_MAX);

		if (measurement_state == SAVE) {/* vȂf[^ۑ */
			if (count==1) {
				sprintf (cbuf, "Number\tTime(s)\tX_Data\tY_Data\r\n");
				SaveInTheFile (NEW, cbuf);
			}
			sprintf(cbuf,"%d\t%f\t%f\t%f\r\n", count, elapsed_time, x_data, y_data);
			SaveInTheFile (EXISTING, cbuf);	
		}
		count++;		
	}

	SaveMemo();

	return 0;
}